import logging
import xlwings as xw

def get_env_vars_from_excel_on_disk(env, filepath, table_name, names_col, excel_visible=False):
    logging.debug(f'Loading {env=} environment variables {table_name=} in {filepath=}')
    excel_app = xw.App(visible=excel_visible)
    wb = xw.Book(filepath)
    keys = xw.Range(f'{table_name}[{names_col}]').value    ;logging.debug(f'Retrieved variable names \n {keys}')
    vals = xw.Range(f'{table_name}[{env}]').value       ;logging.debug(f'Retrieved variable values \n {vals}')
    vars = dict(zip(keys, vals))                        ;logging.debug(f'Matched names with values \n {vals}')
    wb.close()                                          ;logging.debug('Closing book')
    excel_app.quit()            
    excel_app.kill()                                    ;logging.debug('Killing Excel app instance')
    return vars